import 'package:example/models/printer.dart';
import 'package:example/services/print.dart';
import 'package:flutter/material.dart';

class HomePage extends StatefulWidget {
  @override
  _HomePageState createState() => _HomePageState();
}

class _HomePageState extends State<HomePage> {
  List<Printer> _printers = [];

  final _printerService = PrintService();

  @override
  void initState() {
    _scan();

    super.initState();
  }

  _scan() async {
    final _printersFound = await _printerService.scan();

    setState(() {
      _printers.addAll(_printersFound);
    });
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('Zpl App'),
        actions: [
          IconButton(
            icon: Icon(Icons.refresh),
            onPressed: _scan,
          ),
        ],
      ),
      body: Builder(builder: (context) {
        if (_printers.isEmpty) {
          return Center(
            child: Text('Not found'),
          );
        }

        return ListView.builder(
          itemBuilder: (context, index) {
            final _device = _printers[index];

            return ListTile(
              title: Text(_device.name),
              subtitle: Text(_device.address),
              onTap: () async {
                _printerService.printTest(_device);
              },
            );
          },
          itemCount: _printers.length,
        );
      }),
    );
  }
}
