abstract class RootComponent implements SingleChildComponent {}

abstract class Component {
  double x;
  double y;
  double height;

  Component parent;

  Component setPosition({
    double x,
    double y,
  }) {
    this.x = x;
    this.y = y;

    return this;
  }

  /// Builds this ZPL composer instance
  /// [BuildContext context] represents the parent
  /// component that requested this instance to build
  String build({Component parent});
}

abstract class SingleChildComponent implements Component {
  Component child;
}

abstract class MultiChildComponent implements Component {
  List<Component> children;
}
